dojo.require("dojox.uuid.Uuid");
dojo.require("com.ibm.mm.builder.widget.CustomDialog");
dojo.require("com.ibm.mashups.enabler.logging.Logger");
dojo.require("com.ibm.mm.builder.iwidget.SystemWidget");
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");
dojo.declare("com.ibm.mm.builder.systemwidget.SystemMessageWidget",com.ibm.mm.builder.iwidget.SystemTemplatedWidget,{infoEnabled:null,warnEnabled:null,errorEnabled:null,_hasMessage:false,messageDialog:null,currentLevel:0,currentPageMode:"view",handlerID:"com.ibm.mm.builder.systemwidget.SystemMessageWidget",logLevel:com.ibm.mashups.enabler.logging.LogLevel.INFO,onLoad:function(){
this.loadWidgetPref();
this.LOGGER.addHandler(this);
dojo.subscribe(com.ibm.mm.builder.eventTopics.Open_Catalog,this,"whenGotoCatalog");
},onView:function(){
this.inherited(arguments);
dojo.toggleClass(this.messageBoxConfigButtons,"mmSystemMessageInfoBtnOnClick",this.infoEnabled);
dojo.toggleClass(this.messageBoxConfigButtons,"mmSystemMessageWarnBtnOnClick",!this.infoEnabled&&this.warnEnabled);
this.errorEnabled=!this.infoEnabled&&!this.warnEnabled;
dojo.toggleClass(this.messageBoxConfigButtons,"mmSystemMessageErrorBtnOnClick",this.errorEnabled);
this._setA11YHint();
},loadWidgetPref:function(){
var _1=this.iContext.getiWidgetAttributes();
if(_1){
this.infoEnabled=(_1.getItemValue("infoEnabled")=="true");
this.warnEnabled=(_1.getItemValue("warnEnabled")=="true");
this.errorEnabled=(_1.getItemValue("errorEnabled")=="true");
}
},onPageModeChanged:function(_2){
var _3=_2.payload;
this.currentPageMode=_3;
if(_3=="view"&&this.messageDialog){
this.messageDialog.hide();
}
},createMessageDialog:function(){
var _4=this.iContext.getiWidgetAttributes();
this.messageDialog=new com.ibm.mm.builder.widget.CustomDialog({id:"mm_systemMessage_dialog",title:this.cws.I_SYSTEM_MESSAGE_NAME,nodeWidth:"414px",containerBackgroundColor:"white",hasRightBottomResizer:false,displayCloseButton:true,modelDialog:_4.getItemValue("isModel")=="true",sharedWidget:true},this.messageBox);
dojo.style(this.messageBox,"display","");
},displayMessage:function(){
if(this._hasMessage===false){
return;
}
if(!this.messageDialog){
this.createMessageDialog();
}
this.messageDialog.show();
},whenGotoCatalog:function(){
if(this.messageDialog){
this.messageDialog.hide();
}
},getHandlerID:function(){
return this.handlerID;
},getLogLevel:function(){
return this.logLevel;
},log:function(_5,_6,_7,_8){
if(_6<com.ibm.mashups.enabler.logging.LogLevel.INFO){
return;
}
if(this.currentPageMode=="view"&&_6!=com.ibm.mashups.enabler.logging.LogLevel.SEVERE){
return;
}
_8=(_8||_7)+"";
if(!_8){
return;
}
var _9=null;
if(_8.indexOf("BMWMB")===0){
_9=_8.substring(0,_8.indexOf(":"));
_8=_8.substring(_8.indexOf(":")+1);
}
_9=_9?dojo.string.substitute(this.cws.I_SYSTEM_MESSAGE_MSG_CODE,[_9]):"";
var _a="",_b="",_c=0,_d="system message image",_e=false;
var _f="";
switch(_6){
case com.ibm.mashups.enabler.logging.LogLevel.INFO:
_e=this.infoEnabled;
_f=builderConfig.builderPath+"/images/systemmessage/info_icon.png";
_b="mmSystemMessageInfo_img";
_a="mmSystemMessageInfo";
_c=1;
_d=this.cws.MESSAGE_BOX_ICON_INFO;
break;
case com.ibm.mashups.enabler.logging.LogLevel.WARNING:
_e=this.warnEnabled||this.infoEnabled;
_f=builderConfig.builderPath+"/images/systemmessage/warning_icon.png";
_b="mmSystemMessageWarning_img";
_a="mmSystemMessageWarning";
_c=2;
_d=this.cws.MESSAGE_BOX_ICON_WARN;
break;
case com.ibm.mashups.enabler.logging.LogLevel.SEVERE:
_e=this.errorEnabled||this.warnEnabled||this.infoEnabled;
_f=builderConfig.builderPath+"/images/systemmessage/error_icon.png";
_b="mmSystemMessageError_img";
_a="mmSystemMessageError";
_c=3;
_d=this.cws.MESSAGE_BOX_ICON_ERROR;
break;
}
this._hasMessage=true;
dojo.addClass(this.messageIcon,"mmSystemMessageIconClickable");
this.messageIcon.setAttribute("tabIndex","0");
this.messageImage.src=_f;
dojo.style(this.messageImage,"display","");
if(_c>=3){
dijit.setWaiRole(this.messageIcon,"alert");
}else{
dijit.removeWaiRole(this.messageIcon,"alert");
}
if(_c>this.currentLevel){
var _10=(this.currentLevel==2?"mmSystemMessageWarning_img":"mmSystemMessageInfo_img");
dojo.removeClass(this.messageIcon,_10);
dojo.addClass(this.messageIcon,_b);
dojo.attr(this.messageIcon,"title",_d);
dijit.setWaiState(this.messageIcon,"label",_d);
this.currentLevel=_c;
}
if(!_e){
_a+=" mmSystemMessageHidden";
}
var _11=dojox.uuid.generateTimeBasedUuid().replace(/\-/g,"")+"_1",_12=dojox.uuid.generateTimeBasedUuid().replace(/\-/g,"")+"_2";
this.appendMessage(dojo.string.substitute("<div class=\"${0}\">"+"<div tabindex=0 class=\"mmSystemMessageInfoContent\" aria-labelledby=\""+_11+" "+_12+"\">"+"<img id=\""+_11+"\" class=\"mmSystemMessageTypeIcon\" src=\"${2}\" alt=\"${1}\">"+"<div class=\"mmSystemMessageMsgContent\" id=\""+_12+"\">"+"<span>"+"<span>${3}</span>"+"<div class=\"mmSystemMessageMsgCode\">${4}</div>"+"</span>"+"</div>"+"</div>"+"<div class=\"mmSystemMessageInfoBreakLine\"></div>"+"</div>",[_a,_d,_f,_8,_9]));
},appendMessage:function(_13){
this.messageBoxConsole.innerHTML+=_13;
},clear:function(){
this.messageBoxConsole.innerHTML="";
this.currentLevel=0;
dojo.style(this.messageImage,"display","none");
this._hasMessage=false;
dojo.removeClass(this.messageIcon,"mmSystemMessageIconClickable");
this.messageIcon.removeAttribute("tabIndex");
},onClickErrorBtn:function(e){
if(!this.errorEnabled){
this.errorEnabled=true;
this.reFormatMessage("Error",this.errorEnabled);
if(this.warnEnabled){
this.warnEnabled=false;
this.reFormatMessage("Warning",false);
}
if(this.infoEnabled){
this.infoEnabled=false;
this.reFormatMessage("Info",false);
this.reFormatMessage("Warning",false);
}
com.ibm.mm.builder.utils.htmlUtil.setClass(this.messageBoxConfigButtons,"mmSystemMessageErrorBtnOnClick");
com.ibm.mm.builder.utils.htmlUtil.setClass(this.errorBtn,"mmSystemMessageErrorBorder");
dojo.removeClass(this.infoBtn,"mmSystemMessageInfoBorder");
dojo.removeClass(this.warnBtn,"mmSystemMessageWarnBorder");
}
this._setA11YHint();
},onClickWarnBtn:function(e){
if(!this.warnEnabled){
this.errorEnabled=false;
this.warnEnabled=true;
this.reFormatMessage("Warning",true);
if(this.infoEnabled){
this.infoEnabled=false;
this.reFormatMessage("Info",false);
}
com.ibm.mm.builder.utils.htmlUtil.setClass(this.messageBoxConfigButtons,"mmSystemMessageWarnBtnOnClick");
com.ibm.mm.builder.utils.htmlUtil.setClass(this.errorBtn,"mmSystemMessageErrorBorder");
com.ibm.mm.builder.utils.htmlUtil.setClass(this.warnBtn,"mmSystemMessageWarnBorder");
dojo.removeClass(this.infoBtn,"mmSystemMessageInfoBorder");
}
this._setA11YHint();
},onClickInfoBtn:function(e){
if(!this.infoEnabled){
this.infoEnabled=true;
this.errorEnabled=false;
if(!this.warnEnabled){
this.reFormatMessage("Warning",true);
}
this.warnEnabled=false;
this.reFormatMessage("Info",true);
com.ibm.mm.builder.utils.htmlUtil.setClass(this.messageBoxConfigButtons,"mmSystemMessageInfoBtnOnClick");
com.ibm.mm.builder.utils.htmlUtil.setClass(this.errorBtn,"mmSystemMessageErrorBorder");
com.ibm.mm.builder.utils.htmlUtil.setClass(this.warnBtn,"mmSystemMessageWarnBorder");
com.ibm.mm.builder.utils.htmlUtil.setClass(this.infoBtn,"mmSystemMessageInfoBorder");
}
this._setA11YHint();
},reFormatMessage:function(_14,_15){
dojo.query(".mmSystemMessage"+_14,this.messageBoxConsole).forEach(function(_16){
dojo.toggleClass(_16,"mmSystemMessageHidden",!_15);
});
},save:function(){
var att=this.iContext.getiWidgetAttributes();
att.setItemValue("infoEnabled",this.infoEnabled);
att.setItemValue("warnEnabled",this.warnEnabled);
att.setItemValue("errorEnabled",this.errorEnabled);
att.save();
this.messageDialog.hide();
},_setA11YHint:function(){
var _17=this.infoEnabled||this.warnEnabled;
var _18=_17||this.errorEnabled;
if(this.infoEnabled){
this.infoBtn.alt="info is selected";
}else{
this.infoBtn.alt="info";
}
if(_17){
this.warnBtn.alt="warn is selected";
}else{
this.warnBtn.alt="warn";
}
if(_18){
this.errorBtn.alt="error is selected";
}else{
this.errorBtn.alt="error";
}
},onMessageIconPressed:function(evt){
if(evt.charCode==dojo.keys.SPACE||evt.keyCode==dojo.keys.ENTER){
this.displayMessage();
}
}});

